=== debian/changelog ===
strawberry (0.7.2-0.1~mx19+1) mx; urgency=medium

  * Import new upstream release:
    - Fixed incorrectly mapped global shortcuts keys "2" and "3".
    - Fixed Last.fm scrobbling to correctly start array notation for parameters
      at 0 and not 1.
    - Fixed sending trackNumber correctly for Last.fm and Libre.fm scrobbling.
    - Fixed collection search when using special characters in the search query.
    - Fixed reading and saving MP4 lyrics tag.
    - Fixed reading ASF comment tag.
    - Fixed adding playlist songs outside the collection when there are multiple
      files with the same URL.
    - Fixed the rescan songs option to work with local songs outside of the
      collection.
    - Fixed problems with editing song metadata in the playlists.
    - Fixed saving and restoring playlist scrollbar position when switching
      between playlists.
    - Fixed minor issue in cue parser with date and genre.
    - Simplified and improved startup behaviour code.
    - Adapted all source code to be compatible with Qt 6, and increased required
      Qt version to 5.8.
    - Added option to compile with Qt 6 (-DWITH_QT6=ON).
    - Base warning for show in file browser on unique directories to avoid
      unneeded warning about opening many files.
    - Use album artist instead of artist for album repeat mode when available.
    - Added extra safety for overwriting files for filesystem storages when
      organizing files.
    - Remove diacritics in FTS search.
    - Improved playlist context menu.
    - Added fatal CMake error for missing protobuf compiler.
    - Added support for parsing radio streams metadata with tilde in title.
    - Added CMake option to install translation files.
    - Increased maximum time step for seeking to 60.
    - Added playback actions to desktop file.
    - Removed Xine engine support.
    - Removed broken imobiledevice (iPhone) support.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 16 Aug 2020 17:26:40 -0700

strawberry (0.6.13-0.1~mx19+1) mx; urgency=medium

  * Import new upstream release:
    - Fixed cut-off text in about dialog.
    - Fixed increasing play count when stop after track is enabled.
    - Fixed showing/hiding playing widget when playback is started while window
      is hidden.
    - Fixed "Show in file browser" to also work on local songs that are not in
      the collection.
    - Fixed "Show in file browser" to work with PCManFM file manager.
    - Fixed audio analyzer to work with S24LE and F32LE audio formats.
    - Fixed playlist background image not loading.
    - Fixed a memory leak when switching between playlists.
    - Removed use of HTML in systemtray tooltip on KDE, since KDE no longer
      renders HTML in the systemtray.
    - Replaced use of C style casts.
    - Adapted use of C++11 override.
    - Improved CMake build files.
    - Added new on startup options to show maximized or minimized.
    - Builtin TagLib code is updated and improved.
    - Made most icon sizes configurable in the settings, and increased default
      sizes for icons.
    - Improved fancy tabbar to use font sizes from the theme instead of
      fixed sizes.
    - Moving the currently playing song to the top when the playlist is manually
      shuffled.
    - Added "a taste of Strawbs" background image.
    - Fixed unit test for testing playlist model.
    _ Added new unit tests for tagreader.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 18 Jul 2020 00:52:46 -0700
