=== debian/control ===
Source: strawberry
Section: sound
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Jonas Kvinge <jonas@jkvinge.net>
Build-Depends: cmake (>= 2.8.11),
               debhelper (>= 10),
               libasound2-dev,
               libboost-dev,
               libcdio-dev,
               libchromaprint-dev,
               libdbus-1-dev,
               libfftw3-dev,
               libglib2.0-dev,
               libgpod-dev (>= 0.7.92),
               libgstreamer-plugins-base1.0-dev,
               libgstreamer1.0-dev,
               libmtp-dev (>= 1.0),
               libplist-dev,
               libprotobuf-dev,
               libpulse-dev,
               libqt5x11extras5-dev (>= 5.8),
               libsqlite3-dev  (>= 3.7),
               libtag1-dev,
               libusbmuxd-dev,
               protobuf-compiler,
               qtbase5-dev (>= 5.8),
               qtbase5-dev-tools (>= 5.8),
               qtbase5-private-dev (>= 5.8),
               qttools5-dev-tools (>= 5.8)
Standards-Version: 3.9.8

Package: strawberry
Architecture: any
Depends: gstreamer1.0-alsa,
         gstreamer1.0-plugins-base,
         gstreamer1.0-plugins-good,
         gstreamer1.0-pulseaudio,
         libqt5sql5-sqlite (>= 5.8),,
         libsqlite3-0,
         ${misc:Depends},
         ${shlibs:Depends}
Homepage: http://www.strawbs.org/
Description: Audio player and music collection organizer
 Strawberry is a music player aimed at music collectors, audio enthusiasts and
 audiophiles.
 .
 Features:
  - Play and organize music
  - Supports WAV, FLAC, WavPack, DSF, DSDIFF, Ogg Vorbis, Speex, MPC, TrueAudio,
    AIFF, MP4, MP3 and ASF
  - Audio CD playback
  - Native desktop notifications
  - Playlists in multiple formats
  - Advanced audio output and device configuration for bit-perfect playback
    on Linux
  - Edit tags on music files
  - Fetch tags from MusicBrainz
  - Album cover art from Last.fm, Musicbrainz, Discogs, Musixmatch, Deezer,
    Tidal, Qobuz and Spotify
  - Song lyrics from AudD, Genius, Musixmatch, ChartLyrics, lyrics.ovh
    and lololyrics.com
  - Support for multiple backends
  - Audio analyzer
  - Audio equalizer
  - Transfer music to iPod, iPhone, MTP or mass-storage USB player
  - Scrobbler with support for Last.fm, Libre.fm and ListenBrainz
  - Streaming support for Subsonic
 .
 Strawberry is a fork of Clementine. The name is inspired by the band Strawbs.
